
clear;
clc;

T=10;

%% Hayes Roth
load HR;
X=HR;
Pm.Owd=2;
ACC=zeros(1,T);
ARI=zeros(1,T);
NMI=zeros(1,T);
[Pm.Xlth,Pm.Xwd]=size(X);
XLable=X(:,Pm.Xwd);
Pm.Xwd=Pm.Xwd-1;
Pm.Bwd=Pm.Owd;
Pm.k=max(XLable);
Modes=zeros(Pm.k,Pm.Xwd);
rand('seed',9);
for t=1:T
    Modes(1,:)=X(randperm(Pm.Xlth,1),1:Pm.Xwd);
    MoNum=1;
    while MoNum~=Pm.k
        MoNum=MoNum+1;
        Modes(MoNum,:)=X(randperm(Pm.Xlth,1),1:Pm.Xwd);
        for j=1:MoNum-1
            if dist(Modes(MoNum,:),Modes(j,:)')==0
                MoNum=MoNum-1;
            end
        end
    end
    [ACC(t),ARI(t),NMI(t)] = KMD_Main(X,Modes,Pm.Owd);
end
disp(' ');
disp('HR with 2 ordinal and 2 nominal attributes:');
CA=mean(ACC)
ARI=mean(ARI)
NMI=mean(NMI)

%% Mammographic Mass
load MM;
X=MM;
Pm.Owd=2;
ACC=zeros(1,T);
ARI=zeros(1,T);
NMI=zeros(1,T);
[Pm.Xlth,Pm.Xwd]=size(X);
XLable=X(:,Pm.Xwd);
Pm.Xwd=Pm.Xwd-1;
Pm.Bwd=Pm.Owd;
Pm.k=max(XLable);
Modes=zeros(Pm.k,Pm.Xwd);
rand('seed',9);
for t=1:T
    Modes(1,:)=X(randperm(Pm.Xlth,1),1:Pm.Xwd);
    MoNum=1;
    while MoNum~=Pm.k
        MoNum=MoNum+1;
        Modes(MoNum,:)=X(randperm(Pm.Xlth,1),1:Pm.Xwd);
        for j=1:MoNum-1
            if dist(Modes(MoNum,:),Modes(j,:)')==0
                MoNum=MoNum-1;
            end
        end
    end
    [ACC(t),ARI(t),NMI(t)] = KMD_Main(X,Modes,Pm.Owd);
end
disp(' ');
disp('MM with 2 ordinal and  2 nominal attributes:');
CA=mean(ACC)
ARI=mean(ARI)
NMI=mean(NMI)

%% Lym Graph
load LG;
X=LG;
Pm.Owd=3;
ACC=zeros(1,T);
ARI=zeros(1,T);
NMI=zeros(1,T);
[Pm.Xlth,Pm.Xwd]=size(X);
XLable=X(:,Pm.Xwd);
Pm.Xwd=Pm.Xwd-1;
Pm.k=max(XLable);
Modes=zeros(Pm.k,Pm.Xwd);
rand('seed',9);
for t=1:T
    Modes(1,:)=X(randperm(Pm.Xlth,1),1:Pm.Xwd);
    MoNum=1;
    while MoNum~=Pm.k
        MoNum=MoNum+1;
        Modes(MoNum,:)=X(randperm(Pm.Xlth,1),1:Pm.Xwd);
        for j=1:MoNum-1
            if dist(Modes(MoNum,:),Modes(j,:)')==0
                MoNum=MoNum-1;
            end
        end
    end
    [ACC(t),ARI(t),NMI(t)] = KMD_Main(X,Modes,Pm.Owd);
end
disp(' ');
disp('LG with 3 ordinal and 15 nominal attributes:');
CA=mean(ACC)
ARI=mean(ARI)
NMI=mean(NMI)

%% Lecturer Evaluation
load LE;
X=LE;
Pm.Owd=4;
Pm.Bwd=Pm.Owd;
ACC=zeros(1,T);
ARI=zeros(1,T);
NMI=zeros(1,T);
[Pm.Xlth,Pm.Xwd]=size(X);
XLable=X(:,Pm.Xwd);
Pm.Xwd=Pm.Xwd-1;
Pm.k=max(XLable);
Modes=zeros(Pm.k,Pm.Xwd);
rand('seed',9);
for t=1:T
    Modes(1,:)=X(randperm(Pm.Xlth,1),1:Pm.Xwd);
    MoNum=1;
    while MoNum~=Pm.k
        MoNum=MoNum+1;
        Modes(MoNum,:)=X(randperm(Pm.Xlth,1),1:Pm.Xwd);
        for j=1:MoNum-1
            if dist(Modes(MoNum,:),Modes(j,:)')==0
                MoNum=MoNum-1;
            end
        end
    end
    [ACC(t),ARI(t),NMI(t)] = KMD_Main(X,Modes,Pm.Owd);
end
disp(' ');
disp('LE with 4 ordinal atttributes:');
CA=mean(ACC)
ARI=mean(ARI)
NMI=mean(NMI)

%% Voting
load VT;
X=VT;
Pm.Owd=0;
ACC=zeros(1,T);
ARI=zeros(1,T);
NMI=zeros(1,T);
[Pm.Xlth,Pm.Xwd]=size(X);
XLable=X(:,Pm.Xwd);
Pm.Xwd=Pm.Xwd-1;
Pm.k=max(XLable);
Modes=zeros(Pm.k,Pm.Xwd);
rand('seed',9);
for t=1:T
    Modes(1,:)=X(randperm(Pm.Xlth,1),1:Pm.Xwd);
    MoNum=1;
    while MoNum~=Pm.k
        MoNum=MoNum+1;
        Modes(MoNum,:)=X(randperm(Pm.Xlth,1),1:Pm.Xwd);
        for j=1:MoNum-1
            if dist(Modes(MoNum,:),Modes(j,:)')==0
                MoNum=MoNum-1;
            end
        end
    end
    [ACC(t),ARI(t),NMI(t)] = KMD_Main(X,Modes,Pm.Owd);
end
disp(' ');
disp('VT with 16 nominal attributes:');
CA=mean(ACC)
ARI=mean(ARI)
NMI=mean(NMI)

%% Zoo
load ZO;
X=ZO;
Pm.Owd=0;
ACC=zeros(1,T);
ARI=zeros(1,T);
NMI=zeros(1,T);
[Pm.Xlth,Pm.Xwd]=size(X);
XLable=X(:,Pm.Xwd);
Pm.Xwd=Pm.Xwd-1;
Pm.k=max(XLable);
Modes=zeros(Pm.k,Pm.Xwd);
rand('seed',9);
for t=1:T
    Modes(1,:)=X(randperm(Pm.Xlth,1),1:Pm.Xwd);
    MoNum=1;
    while MoNum~=Pm.k
        MoNum=MoNum+1;
        Modes(MoNum,:)=X(randperm(Pm.Xlth,1),1:Pm.Xwd);
        for j=1:MoNum-1
            if dist(Modes(MoNum,:),Modes(j,:)')==0
                MoNum=MoNum-1;
            end
        end
    end
    [ACC(t),ARI(t),NMI(t)] = KMD_Main(X,Modes,Pm.Owd);
end
disp(' ');
disp('ZO with 16 nominal attributes:');
CA=mean(ACC)
ARI=mean(ARI)
NMI=mean(NMI)



