
function [X,Pm,AttMtx] = UDMPre(X,Pm)

X=X(:,1:Pm.Xwd);
ValNum=zeros(Pm.Xwd,1);
for i=1:Pm.Xwd
    ValNum(i)=max(X(:,i));
end
WeightMtx=zeros(Pm.Xwd);
for i=1:Pm.Xwd
    for j=1:Pm.Xwd
        ConMtx=zeros(ValNum(i));
        Mid=0;
        for m=1:ValNum(i)
            MValLct=find(X(:,i)==m);
            CorValM=X(MValLct,j);
            for h=1:ValNum(i)
                if h>m
                    HValLct=find(X(:,i)==h);
                    CorValH=X(HValLct,j);
                    % ordinal-ordinal case
                    if i<=Pm.Owd && j<=Pm.Owd
                        for r=1:length(MValLct)
                            for g=1:length(HValLct)
                                if CorValM(r)<CorValH(g)
                                    ConMtx(m,h)=ConMtx(m,h)+1;
                                end
                                if CorValM(r)>CorValH(g)
                                    ConMtx(h,m)=ConMtx(h,m)+1;
                                end
                            end
                        end
                    end
                    if i>Pm.Owd || j>Pm.Owd
                        ConMtxMH=zeros(ValNum(j));
                        for r=1:length(MValLct)
                            for g=1:length(HValLct)
                                if CorValM(r)~=CorValH(g)
                                    ConMtxMH(CorValM(r),CorValH(g))=ConMtxMH(CorValM(r),CorValH(g))+1;
                                end
                            end
                        end
                        SubCon=0;
                        SubDisCon=0;
                        for r=1:ValNum(j)
                            for g=1:ValNum(j)
                                if g>r
                                    if ConMtxMH(r,g)>ConMtxMH(g,r)
                                        SubCon=SubCon+ConMtxMH(r,g);
                                        SubDisCon=SubDisCon+ConMtxMH(g,r);
                                    end
                                    if ConMtxMH(r,g)<ConMtxMH(g,r)
                                        SubCon=SubCon+ConMtxMH(g,r);
                                        SubDisCon=SubDisCon+ConMtxMH(r,g);
                                    end
                                end
                            end
                        end
                        ConMtx(m,h)=sum(sum(SubCon));
                        ConMtx(h,m)=sum(sum(SubDisCon));
                    end
                end
            end
            CorValMCandi=unique(CorValM);
            for u=1:length(CorValMCandi)
                SubMidLth=length(find(CorValM==CorValMCandi(u)));
                if SubMidLth>1
                    Mid=Mid+SubMidLth*(SubMidLth-1)/2;
                end
            end
        end
        Con=0;
        DisCon=0;
        for r=1:ValNum(i)
            for g=1:ValNum(i)
                if g>r
                    Con=Con+ConMtx(r,g);
                end
                if g<r
                    DisCon=DisCon+ConMtx(r,g);
                end
            end
        end
        WeightMtx(i,j)=2*(abs(Con-DisCon)+Mid)/(Pm.Xlth*(Pm.Xlth-1));      
    end  
end
AttMtx=cell(Pm.Xwd,1);
for i=1:Pm.Xwd
    if i<=Pm.Owd
        DistMtx=zeros(ValNum(i));
        for m=1:ValNum(i) 
            for h=1:ValNum(i)
                if h>m
                    SubDist=zeros(1,Pm.Xwd);
                    for j=1:Pm.Xwd
                        SubSubDist=zeros(1,h-m);
                        for g=m:h-1
                            ValListM=X(X(:,i)==g,j);
                            ValListH=X(X(:,i)==g+1,j);
                            ValList=[ValListM;ValListH];
                            SubSubDist(g) = Entropy(ValList,X(:,j),ValNum(j));
                        end
                        SubDist(j)=sum(SubSubDist);
                    end
                    DistMtx(m,h)=mean(SubDist.*WeightMtx(i,:));
                    DistMtx(h,m)=DistMtx(m,h);
                end
            end
        end
        AttMtx{i}=DistMtx;
    end
    if i>Pm.Owd
        DistMtx=zeros(ValNum(i));
        for m=1:ValNum(i)
            for h=1:ValNum(i)
                if h>m
                    SubDist=zeros(1,Pm.Xwd);
                    for j=1:Pm.Xwd
                        ValListM=X(X(:,i)==m,j);
                        ValListH=X(X(:,i)==h,j);
                        ValList=[ValListM;ValListH];
                        SubDist(j) = Entropy(ValList,X(:,j),ValNum(j));
                    end
                    DistMtx(m,h)=mean(SubDist.*WeightMtx(i,:));
                    DistMtx(h,m)=DistMtx(m,h);
                end
            end
        end
        AttMtx{i}=DistMtx;
    end
end

end

